<?php

namespace App\Models\Enums;

use App\Models\Asset;
use App\Models\Plan;
use App\Models\Project;
use App\Models\Task;

enum ActionObjectType: string
{
    case ASSET = "asset";

    case PROJECT = "project";

    case TASK = "task";

    case PLAN = "plan";

    public function modelBuilder(): \Illuminate\Database\Eloquent\Builder
    {
        return match ($this) {
            self::ASSET => Asset::query(),
            self::PROJECT => Project::query(),
            self::TASK => Task::query(),
            self::PLAN => Plan::query(),
        };
    }

    public function nameField(): string
    {
        return match ($this) {
            self::ASSET, self::PROJECT, self::TASK  => "name",
            self::PLAN => "title",
        };
    }
}
